/*
 * Copyright (c) 2021, Kyungguk Min
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include "H5Type.h"

HDF5KIT_NAMESPACE_BEGIN(1)

#define STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(type, map)                                          \
    Type::Native<type>::Native() noexcept : Type{ map, nullptr } {}

STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(char, H5T_NATIVE_CHAR)
STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(unsigned char, H5T_NATIVE_UCHAR)
STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(short, H5T_NATIVE_SHORT)
STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(unsigned short, H5T_NATIVE_USHORT)
STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(int, H5T_NATIVE_INT)
STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(unsigned, H5T_NATIVE_UINT)
STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(long, H5T_NATIVE_LONG)
STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(unsigned long, H5T_NATIVE_ULONG)
STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(float, H5T_NATIVE_FLOAT)
STAMP_NATIVE_TYPE_CLASS_IMPLEMENTATION(double, H5T_NATIVE_DOUBLE)

HDF5KIT_NAMESPACE_END(1)
